<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "practice_treatment".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PracticeTreatment".
 *
 * Columns in table "practice_treatment" available as properties of the model,
 * followed by relations of table "practice_treatment" available as properties of the model.
 *
 * @property integer $id
 * @property integer $practice_id
 * @property integer $treatment_id
 *
 * @property Practice $practice
 * @property Treatment $treatment
 */
abstract class BasePracticeTreatment extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'practice_treatment';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('practice_id, treatment_id', 'required'),
            array('practice_id, treatment_id', 'numerical', 'integerOnly' => true),
            array('id, practice_id, treatment_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'treatment' => array(self::BELONGS_TO, 'Treatment', 'treatment_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'practice_id' => Yii::t('app', 'Practice'),
            'treatment_id' => Yii::t('app', 'Treatment'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->with = array('treatment', 'practice');

        //it will search by id or practice.name
        if (!intval($this->practice_id) && is_string($this->practice_id) && strlen($this->practice_id) > 0) {
            $criteria->with[] = 'practice';
            $criteria->addSearchCondition("practice.name", $this->practice_id);
        } else
            $criteria->compare('practice_id', $this->practice_id);

        if (!intval($this->treatment_id) && is_string($this->treatment_id) && strlen($this->treatment_id) > 0) {
            $criteria->with[] = 'treatment';
            $criteria->addSearchCondition("treatment.name", $this->treatment_id);
        } else
            $criteria->compare('treatment_id', $this->treatment_id);


        return new CActiveDataPractice(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PracticeTreatment|PracticeTreatments', $n);
    }

}
